/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.alignment.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JScrollPane;

import org.synteny.factory.IconFactory;

public class MultipleAlignmentHtmlView extends JDialog implements ActionListener {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8269789423589051808L;

	private JButton closeButton;
	private String htmlAlignment;
	private JLabel editorPane;
	
	public MultipleAlignmentHtmlView(String htmlAlignment){
		this.htmlAlignment = htmlAlignment;
		setTitle("Alignement viewer");
		setLayout(new BorderLayout());
		((java.awt.Frame)getOwner()).setIconImage(IconFactory.getInstance().getLogoIcon().getImage());
		
		add(new JScrollPane(getHtmlView()),BorderLayout.CENTER);
		add(getCloseButton(),BorderLayout.SOUTH);
		
		setSize(500,600);
		setModal(true);
		setLocationRelativeTo(null);
		
	}
	
	public JButton getCloseButton(){
		if(closeButton == null){
			closeButton = new JButton("close");
			closeButton.addActionListener(this);
		}
		return closeButton;
	}
	
	public JLabel getHtmlView(){
		if(editorPane == null){
			editorPane = new JLabel();
			editorPane.setBackground(Color.white);
			editorPane.setText(htmlAlignment);
		}
		return editorPane;
	}

	public void actionPerformed(ActionEvent e) {
		dispose();
	}
	
	public static void showMultipleAlignmentHtmlView(String htmlAlignment){
		MultipleAlignmentHtmlView mahv = new MultipleAlignmentHtmlView(htmlAlignment);
		mahv.setVisible(true);
	}
}
