/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny;

import java.util.Collection;


public interface Bloc extends Comparable<Bloc>{

	/**
	 * @return  Returns the comparison.
	 * @uml.property  name="comparison"
	 * @uml.associationEnd  inverse="bloc:org.synteny.Comparison"
	 * @uml.association  name="hasBlocs"
	 */
	public Comparison getComparison();

	/**
	 * Setter of the property <tt>comparison</tt>
	 * @param comparison  The comparison to set.
	 * @uml.property  name="comparison"
	 */
	public void setComparison(Comparison comparison);

	/**
	 * @return  Returns the paralog.
	 * @uml.property  name="paralog"
	 * @uml.associationEnd  multiplicity="(0 -1)" inverse="bloc:org.synteny.Paralog"
	 * @uml.association  name="hasParalogs"
	 */
	public Collection getParalog();

	/**
	 * Setter of the property <tt>paralog</tt>
	 * @param paralog  The paralog to set.
	 * @uml.property  name="paralog"
	 */
	public void setParalog(Collection paralog);


	/**
	 */
	public abstract void addParalog(Paralog paralog);


	/**
	 */
	public abstract int getNbParalogs();


	/**
	 */
	public abstract int getMaximumSize();

	public int getGenomeStart();
	
	public abstract void delete();
	
	public Protein getFirstReferenceProtein();


}
