/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny;

import java.util.List;
import java.util.Map;


public interface Comparison extends Comparable<Comparison>{

	/**
	 * @return  Returns the bloc.
	 * @uml.property  name="bloc"
	 * @uml.associationEnd  multiplicity="(0 -1)" ordering="true" container="java.util.List" inverse="comparison:org.synteny.Bloc"
	 * @uml.association  name="hasBlocs"
	 */
	public List getBloc();

	/**
	 * Setter of the property <tt>bloc</tt>
	 * @param bloc  The bloc to set.
	 * @uml.property  name="bloc"
	 */
	public void setBloc(List bloc);

	/**
	 * @return  Returns the synteny.
	 * @uml.property  name="synteny"
	 * @uml.associationEnd  inverse="comparison:org.synteny.Synteny"
	 * @uml.association  name="hasComparisons"
	 */
	public Synteny getSynteny();

	/**
	 * Setter of the property <tt>synteny</tt>
	 * @param synteny  The synteny to set.
	 * @uml.property  name="synteny"
	 */
	public void setSynteny(Synteny synteny);

	/**
	 * @return  Returns the refGenome.
	 * @uml.property  name="refGenome"
	 * @uml.associationEnd  inverse="comparisonRef:org.synteny.Genome"
	 * @uml.association  name="referenceGenome"
	 */
	public Genome getRefGenome();

	/**
	 * Setter of the property <tt>refGenome</tt>
	 * @param refGenome  The refGenome to set.
	 * @uml.property  name="refGenome"
	 */
	public void setRefGenome(Genome refGenome);

	/**
	 * @return  Returns the compGenome.
	 * @uml.property  name="compGenome"
	 * @uml.associationEnd  inverse="compComparison:org.synteny.Genome"
	 * @uml.association  name="comparisonCom"
	 */
	public Genome getCompGenome();

	/**
	 * Setter of the property <tt>compGenome</tt>
	 * @param compGenome  The compGenome to set.
	 * @uml.property  name="compGenome"
	 */
	public void setCompGenome(Genome compGenome);

	public abstract void addParalog(Paralog paralog);

	/**
	 */
	public abstract int getNbBlocs();


	/**
	 */
	public abstract Map getBlocSizeDistribution();
	
	public abstract void delete();
}
