/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny;


public interface Ortholog {

	/**
	 * @return  Returns the paralog.
	 * @uml.property  name="paralog"
	 * @uml.associationEnd  inverse="ortholog:org.synteny.Paralog"
	 * @uml.association  name="hasOrtholog"
	 */
	public Paralog getParalog();

	/**
	 * Setter of the property <tt>paralog</tt>
	 * @param paralog  The paralog to set.
	 * @uml.property  name="paralog"
	 */
	public void setParalog(Paralog paralog);

	/**
	 * @return  Returns the refProtein.
	 * @uml.property  name="refProtein"
	 * @uml.associationEnd  inverse="ortholog:org.synteny.Protein"
	 * @uml.association  name="hasProtGenomeRef"
	 */
	public Protein getRefProtein();

	/**
	 * Setter of the property <tt>refProtein</tt>
	 * @param refProtein  The refProtein to set.
	 * @uml.property  name="refProtein"
	 */
	public void setRefProtein(Protein refProtein);

	/**
	 * @return  Returns the compProtein.
	 * @uml.property  name="compProtein"
	 * @uml.associationEnd  inverse="ortholog:org.synteny.Protein"
	 * @uml.association  name="hasProtGenomeComp"
	 */
	public Protein getCompProtein();

	/**
	 * Setter of the property <tt>compProtein</tt>
	 * @param compProtein  The compProtein to set.
	 * @uml.property  name="compProtein"
	 */
	public void setCompProtein(Protein compProtein);

	public abstract void delete();

}
