/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny;


public class OrthologImpl implements Ortholog{

	int _orthologId;
	Protein _refProtein;
	Protein _compProtein;
	Paralog _para;
	
	public OrthologImpl(int orthoId,Paralog para){
		_orthologId = orthoId;
		_para = para;
	}
	
	public Protein getCompProtein() {
		return _compProtein;
	}

	public Paralog getParalog() {
		return _para;
	}

	public Protein getRefProtein() {
		return _refProtein;
	}

	public void setCompProtein(Protein compProtein) {
		_compProtein = compProtein;
	}

	public void setParalog(Paralog paralog) {
		_para =  paralog;
	}

	public void setRefProtein(Protein refProtein) {
		_refProtein = refProtein;
	}

	private int getId(){
		return _orthologId;
	}
	
	public boolean equals(Object o){
		if (o instanceof OrthologImpl) {
			OrthologImpl orth = (OrthologImpl) o;
			return (orth.getId()==getId());			
		}
		return false;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode(){
		return getId();
	}
	
	public void delete(){
		_refProtein = null;
		_compProtein.delete();
		_compProtein = null;
		_para = null;
	}
	
}
