/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny;

import java.util.Collection;
import java.util.List;


public interface Paralog {

	/**
	 * @return  Returns the bloc.
	 * @uml.property  name="bloc"
	 * @uml.associationEnd  inverse="paralog:org.synteny.Bloc"
	 * @uml.association  name="hasParalogs"
	 */
	public Collection getBloc();

	/**
	 * Setter of the property <tt>bloc</tt>
	 * @param bloc  The bloc to set.
	 * @uml.property  name="bloc"
	 */
	public void setBloc(Collection bloc);
	
	/**
	 * Add a bloc to the collection of blocs
	 */
	public void addBloc(Bloc b);

	/**
	 * @return  Returns the ortholog.
	 * @uml.property  name="ortholog"
	 * @uml.associationEnd  multiplicity="(0 -1)" ordering="true" container="java.util.List" inverse="paralog:org.synteny.Ortholog"
	 * @uml.association  name="hasOrtholog"
	 */
	public List getOrtholog();

	/**
	 * Setter of the property <tt>ortholog</tt>
	 * @param ortholog  The ortholog to set.
	 * @uml.property  name="ortholog"
	 */
	public void setOrtholog(List ortholog);


	/**
	 */
	public abstract int getIdentifier();


	/**
	 */
	public abstract void addOrtholog(Ortholog ortho);


	/**
	 */
	public abstract boolean intersect(Paralog paralog);

	public abstract void delete();




}
