/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.factory;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

import org.synteny.ihm.preferences.Settings;


public class DatabaseManagerImpl implements DatabaseManager {

	private String _host = "embg.igmors.u-psud.fr";
	private String _user= "flemoine";
	private String _pass= "";
	private String _database= "syntebase_refseq";
	private String _port = "5432";

	private Connection _connection;

	public DatabaseManagerImpl(){
		_host = Settings.getInstance().getDBHost();
		_user = Settings.getInstance().getDBUser();
		_pass = Settings.getInstance().getDBPassword();
		_database = Settings.getInstance().getDBName();
		_port = Settings.getInstance().getDBPort();
	}
	
	public DatabaseQueryResult sendQuery(String query) throws Exception{
		connect();
		Statement st;
		DatabaseQueryResult qr = new DatabaseQueryResult();
		st = _connection.createStatement();
		ResultSet rs = st.executeQuery(query);
		qr.fill(rs);
		rs.close();
		st.close();
		disconnect();
		return qr;
	}

	public void connect() throws SQLException{
		Properties props = new Properties();
		props.setProperty("user",_user);
		props.setProperty("port",_port);
		props.setProperty("password",_pass);
		props.setProperty("loginTimeout", "5");
		String url = "jdbc:postgresql://"+_host+":"+_port+"/"+_database;
		_connection = DriverManager.getConnection(url, props);
	}

	public void disconnect(){
		try {
			_connection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
