/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.factory;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.table.DefaultTableModel;

public class DatabaseQueryResult extends DefaultTableModel {

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 3782587222148576420L;


	public DatabaseQueryResult(ResultSet rs){
		super();
	}
	
	public DatabaseQueryResult(){
		super();
	}

	public void fill(ResultSet rs) throws SQLException{
		int row = 1;
		Vector<String> colsid = new Vector<String>();
		
		for(int i=0;i<rs.getMetaData().getColumnCount();i++){
			colsid.add(rs.getMetaData().getColumnName(i+1));
		}
		setColumnIdentifiers(colsid);
		
		while (rs.next()) {
			setRowCount(row);
			for(int col=1;col<=rs.getMetaData().getColumnCount();col++){
				this.setValueAt(rs.getObject(col), row-1, col-1);
			}
			row++;
		}
	}
}
