/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.factory;

import org.synteny.Synteny;
import org.synteny.SyntenyImpl;


public class HttpSyntenyFactory implements SyntenyFactory {

	SpeciesTreeFactory _spTreeFactory;
	ComparisonsFactory _comparisonFactory;
	GenomeFactory _genomeFactory;
	ProteinInfoSearchFactory _searchFactory;
	
	public Synteny newSyntenyInstance() {
		_spTreeFactory = new HttpSpeciesTreeFactory();
		_comparisonFactory = new HttpComparisonsFactory();
		_genomeFactory = new HttpGenomeFactory();
		Synteny synteny = new SyntenyImpl(_spTreeFactory,_comparisonFactory,_genomeFactory);
		return synteny;
	}

	public ComparisonsFactory getComparisonsFactory() {
		return _comparisonFactory;
	}

	public SpeciesTreeFactory getSpeciesTreeFactory() {
		return _spTreeFactory;
	}

	public void setComparisonsFactory(ComparisonsFactory comparisonsFactory) {
		_comparisonFactory = comparisonsFactory;
	}

	public void setSpeciesTreeFactory(SpeciesTreeFactory speciesTreeFactory) {
		_spTreeFactory = speciesTreeFactory;
	}

	public GenomeFactory getGenomeFactory() {
		return _genomeFactory;
	}

	public void setGenomeFactory(GenomeFactory genomeFactory) {
		_genomeFactory = genomeFactory;
	}

	public ProteinInfoSearchFactory getProteinSearchFactory() {
		// TODO Auto-generated method stub
		return _searchFactory;
	}

	public void setProteinSearchFactory(
			ProteinInfoSearchFactory proteinSearchFactory) {
		_searchFactory = proteinSearchFactory;
	}
}
