/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.factory;

import java.awt.Toolkit;

import javax.swing.ImageIcon;

/**
 * @author lemoine
 * Pattern : Singleton
 * Permet de récupérer les icones utiles pour l'application
 * Besoins de icu...jar
 */
public class IconFactory {
	private static IconFactory _instance = null;

	ImageIcon _playIcon = null;
	ImageIcon _openIcon = null;
	ImageIcon _saveIcon = null;
	ImageIcon _backIcon = null;
	ImageIcon _forwardIcon = null;
	ImageIcon _exportIcon = null;
	ImageIcon _refreshIcon = null;
	ImageIcon _newIcon = null;
	ImageIcon _stopIcon = null;
	ImageIcon _dotIcon = null;
	ImageIcon _tabImage= null;
	ImageIcon _histogramImage = null;
	ImageIcon _searchImage = null;
	ImageIcon _specicesImage = null;
	ImageIcon _multiSpeciesImage = null;
	ImageIcon _closeIcon = null;
	ImageIcon _editIcon = null;
	ImageIcon _alignIcon = null;
	ImageIcon _logoIcon = null;
	ImageIcon _aboutIcon = null;
	ImageIcon _yellowProtein = null;
	ImageIcon _whiteProtein = null;
	ImageIcon _blueProtein = null;
	ImageIcon _wheelIcon = null;

	private IconFactory(){

	}

	/**
	 * @return Icone Play
	 */
	public ImageIcon getPlayIcon(){
		if(_playIcon == null){
			_playIcon =new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/media/Play24.gif"))); 
		}
		return _playIcon;
	}

	/**
	 * @return Icone save
	 */
	public ImageIcon getSaveIcon(){
		if(_saveIcon == null ){
			_saveIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/Save24.gif")));
		}
		return _saveIcon;
	}

	/**
	 * @return Icone Open
	 */
	public ImageIcon getOpenIcon(){
		if(_openIcon == null){
			_openIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/Open24.gif")));
		}
		return _openIcon;
	}

	/**
	 * @return Icone back 
	 */
	public ImageIcon getBackIcon(){
		if(_backIcon == null ){
			_backIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/navigation/Back24.gif")));
		}
		return _backIcon;

	}

	/**
	 * @return Icone Forward
	 */
	public ImageIcon getForwardIcon(){
		if(_forwardIcon == null ){
			_forwardIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/navigation/Forward24.gif")));
		}
		return _forwardIcon;
	}

	/**
	 * @return Icone export
	 */
	public ImageIcon getExportIcon(){
		if(_exportIcon == null){
			_exportIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/Export24.gif")));
		}
		return _exportIcon;
	}

	/**
	 * @return Icone refresh
	 */
	public ImageIcon getRefreshIcon(){
		if(_refreshIcon == null){
			_refreshIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/Refresh24.gif")));
		}
		return _refreshIcon;
	}

	/**
	 * @return Icone New
	 */
	public ImageIcon getNewIcon(){
		if(_newIcon == null){
			_newIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/New24.gif")));
		}
		return _newIcon;
	}

	/**
	 * @return Icone Stop
	 */
	public ImageIcon getStopIcon(){
		if(_stopIcon == null){
			_stopIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/Stop24.gif")));
		}
		return _stopIcon;
	}

	public ImageIcon getTabImage(){
		if(_tabImage==null){
			_tabImage = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/tab.png")));
		}
		return _tabImage;
	}


	public ImageIcon getHistogramImage(){
		if(_histogramImage==null){
			_histogramImage = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/histo.png"))); 
		}
		return _histogramImage; 
	}


	public ImageIcon getSearchImage(){
		if(_searchImage==null){
			_searchImage = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/search.png")));
		}
		return _searchImage;
	}

	public ImageIcon getSpeciesImage(){
		if(_specicesImage==null){
			_specicesImage = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/species.png")));
		}
		return _specicesImage;
	}

	public ImageIcon getMultiSpeciesImage(){
		if(_multiSpeciesImage==null){
			_multiSpeciesImage =  new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/multispecies.png")));
		}
		return _multiSpeciesImage;
	}

	public ImageIcon getCloseIcon(){
		if(_closeIcon == null){
			_closeIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/close.png")));
		}
		return _closeIcon;
	}

	public ImageIcon getEditIcon(){
		if(_editIcon == null){
			_editIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/Edit24.gif")));
		}
		return _editIcon;
	}

	public ImageIcon getLogoIcon(){
		if(_logoIcon == null){
			_logoIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/logo_med.png")));
		}
		return _logoIcon;
	}

	public ImageIcon getAlignIcon(){
		if(_alignIcon == null){
			_alignIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/align.png")));
		}
		return _alignIcon;
	}

	public ImageIcon getAboutIcon(){
		if(_aboutIcon == null){
			_aboutIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/toolbarButtonGraphics/general/About24.gif")));
		}
		return _aboutIcon;
	}

	public ImageIcon getYellowProteinIcon(){
		if(_yellowProtein ==null){
			_yellowProtein = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/protein_yellow.png")));
		}
		return _yellowProtein;
	}
	
	public ImageIcon getWhiteProteinIcon(){
		if(_whiteProtein ==null){
			_whiteProtein = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/protein_white.png")));
		}
		return _whiteProtein;
	}

	public ImageIcon getBlueProteinIcon(){
		if(_blueProtein ==null){
			_blueProtein = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/protein_blue.png")));
		}
		return _blueProtein;
	}

	public ImageIcon getWheelIcon(){
		if(_wheelIcon == null){
			_wheelIcon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/files/wheel.png")));
		}
		return _wheelIcon;
	}
	
	/**
	 * @return L'unique instance de IconFactory
	 */
	public static IconFactory getInstance(){
		if(_instance==null){
			_instance = new IconFactory();
		}
		return _instance;
	}
}
