/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collection;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.synteny.factory.IconFactory;
import org.synteny.ihm.preferences.TabLabel;

public class AboutPanel extends JPanel  implements Closable,ActionListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4376491443857793522L;
	private Collection<CloseListener> _closeListeners;
	
	public AboutPanel(){
		_closeListeners = new ArrayList<CloseListener>();
		setLayout(new BorderLayout());
		TabLabel title = new TabLabel("About SynteView");
		title.getCloseButton().addActionListener(this);
		JLabel jb = new JLabel();
		jb.setHorizontalTextPosition(JLabel.CENTER);
		jb.setHorizontalAlignment(JLabel.CENTER);
		jb.setText("<html><body><center><h3> SynteView 1.0 </h3>" +
				"<p><a href=\"http://www.synteview.u-psud.fr\">http://www.synteview.u-psud.fr</a></p><br><brs>"+
				"<h2> IGM / LRI University of Paris Sud</h2><br><br>" +
				"<h4> Fr&eacute;d&eacute;ric Lemoine</h4>" +
				"<p>lemoine@lri.fr</p>"+
				"</center></body></html>");
		
		JLabel logo = new JLabel();
		logo.setIcon(IconFactory.getInstance().getLogoIcon());
		logo.setBackground(Color.WHITE);
		
		JPanel jp = new JPanel();
		jp.setLayout(new BoxLayout(jp,BoxLayout.PAGE_AXIS));
		Box b =Box.createHorizontalBox();
		b.add(Box.createHorizontalGlue());
		b.add(logo);
		b.add(Box.createHorizontalGlue());
		jp.add(b);
		
		Box b2 =Box.createHorizontalBox();
		b2.add(Box.createHorizontalGlue());
		b2.add(jb);
		b2.add(Box.createHorizontalGlue());
		jp.add(b2);

		jp.add(Box.createRigidArea(new Dimension(2,40)));
		
		Box b3 =Box.createHorizontalBox();
		b3.add(Box.createHorizontalGlue());
		JButton jbutton = new JButton("SynteView Help");
		jbutton.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				HelpPanel.showHelpDialog();
			}
		});
		b3.add(jbutton);
		b3.add(Box.createHorizontalGlue());
		jp.add(b3);
		
		jp.setBackground(Color.WHITE);
		
		add(title,BorderLayout.NORTH);
		add(jp,BorderLayout.CENTER);
	}
	
	public void addCloseListener(CloseListener closelistener) {
		_closeListeners.add(closelistener);
	}

	public void close() {
		for(CloseListener cl : _closeListeners){
			cl.ComponentClosed(this);
		}
	}

	public void actionPerformed(ActionEvent e) {
		close();
	}

}
