/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm;

import java.awt.Color;
import java.awt.Font;
import java.awt.Paint;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.CategoryItemRenderer;
import org.jfree.data.category.DefaultCategoryDataset;

/*import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.CategoryItemRenderer;
import org.jfree.data.category.DefaultCategoryDataset;
*/

public class BlocSizeHistogram extends JPanel{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -572209452011621249L;

	public BlocSizeHistogram(Map<Integer,Integer> data, String species1, String species2){
		super();
		DefaultCategoryDataset dd = new DefaultCategoryDataset();
		List<Integer> l = new ArrayList<Integer>(data.keySet());
		Collections.sort(l);
		for(Integer key : l){
			dd.addValue(data.get(key), "size", key);
		}
		
		CategoryItemRenderer renderer = new BarRenderer(){
			public Paint getItemPaint(int row, int column){
				return new Color(200-(4-(column)%4)*50,255,255);
			}
		};
		JFreeChart jfc =  ChartFactory.createBarChart("Blocks size distribution between "+species1+" and "+species2, "Size of blocks", "Number of blocks", dd, PlotOrientation.VERTICAL, false, false, false);
		jfc.setBackgroundPaint(Color.white);
		jfc.getCategoryPlot().setRenderer(renderer);
		jfc.getTitle().setFont(new Font("Arial",Font.PLAIN,13));
		ChartPanel cp = new ChartPanel(jfc);
		cp.setBackground(Color.white);
		add(cp);
		setBackground(Color.white);
		
	}
	
	public static void main(String[] args) {
		Map<Integer,Integer> data  = new HashMap<Integer,Integer>();
		data.put(1, 12);
		data.put(2, 50);
		data.put(8, 85);
		BlocSizeHistogram bsh = new BlocSizeHistogram(data,"Coucou1","Coucou2");
		JFrame jf = new JFrame();
		jf.add(bsh);
		jf.pack();
		jf.setResizable(false);
		jf.setVisible(true);
	}
}
