/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;

import org.synteny.factory.IconFactory;

public class HelpPanel extends JDialog{

	/**
	 * 
	 */
	private static final long serialVersionUID = 304440056550643882L;
	/**
	 * Affichage de la page web
	 */
	private JEditorPane _textPane = null;
	/**
	 * Unique instance
	 */
	private static HelpPanel _instance =  null;

	/**
	 * Constructeur
	 */
	public HelpPanel(){
		((java.awt.Frame)getOwner()).setIconImage(IconFactory.getInstance().getLogoIcon().getImage());
		JScrollPane jsp = new JScrollPane(getTextPane());
		//JEditorPane jsp = getTextPane();
		setTitle("SynteView Help");
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(jsp,BorderLayout.CENTER);
		setSize(new Dimension(550,600));
		setLocationRelativeTo(null);	
	}

	/**
	 * @return le JEditorPane
	 */
	public JEditorPane getTextPane(){
		if(_textPane == null){
			try {
				_textPane = new JEditorPane(new URL("http://www.synteview.u-psud.fr/documentation.html"));
				_textPane.setEditable(false);
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return _textPane;
	}

	/**
	 * Affiche le Dialog de Help
	 */
	public static void showHelpDialog(){
		if(_instance == null){
			_instance = new HelpPanel();
		}
		_instance.setVisible(true);
	}
}
