/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm;

import org.synteny.Ortholog;

/**
 * @uml.dependency   supplier="org.synteny.Protein"
 */
public class OrthologPanel extends ProteinPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7950048695328038750L;

	/**
	 * @uml.property  name="ortholog"
	 * @uml.associationEnd  inverse="proteinPanel:org.synteny.Ortholog"
	 */
	private Ortholog ortholog;

	public OrthologPanel(Ortholog o){
		super(o.getCompProtein());
		ortholog = o;
	}

	/**
	 * Getter of the property <tt>ortholog</tt>
	 * @return  Returns the ortholog.
	 * @uml.property  name="ortholog"
	 */
	public Ortholog getOrtholog() {
		return ortholog;
	}

	/**
	 * Setter of the property <tt>ortholog</tt>
	 * @param ortholog  The ortholog to set.
	 * @uml.property  name="ortholog"
	 */
	public void setOrtholog(Ortholog ortholog) {
		this.ortholog = ortholog;
	}
}
