/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.layout;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.Rectangle;

import org.synteny.ihm.ProteinPanel;
import org.synteny.ihm.SimpleBlocPanel;
import org.synteny.ihm.ComparisonPanel;
import org.synteny.ihm.OrthologPanel;


public class ComparisonLayout implements LayoutManager{

	/**
	 * 
	 */
	private static final long serialVersionUID = 6690220941993512759L;


	public void addLayoutComponent(String name, Component comp) {
		// TODO Auto-generated method stub
		
	}

	public void layoutContainer(Container parent) {
		for(Component c : parent.getComponents()){
			int pos = ((SimpleBlocPanel)c).getGenomePosition();
			//Rectangle rect = new Rectangle(pos*(ProteinPanel.PROTEIN_WIDTH+ProteinPanel.PROTEIN_MARGIN)+ProteinPanel.PROTEIN_MARGIN,ComparisonPanel.COMPARISON_TOP_MARGIN,c.getPreferredSize().width,c.getPreferredSize().height);
			Rectangle rect = new Rectangle(pos*(OrthologPanel.PROTEIN_WIDTH+OrthologPanel.PROTEIN_MARGIN)+OrthologPanel.PROTEIN_MARGIN,ComparisonPanel.COMPARISON_TOP_MARGIN,c.getPreferredSize().width,c.getPreferredSize().height);
			c.setBounds(rect);
		}
	}

	public Dimension minimumLayoutSize(Container parent) {
		return new Dimension(100,100);
	}

	public Dimension preferredLayoutSize(Container parent) {
		int width = ((ComparisonPanel)parent).getComparison().getRefGenome().getSize()*(OrthologPanel.PROTEIN_WIDTH+OrthologPanel.PROTEIN_MARGIN);
		int height = ProteinPanel.PROTEIN_HEIGHT+SimpleBlocPanel.BLOC_MARGIN*2+ComparisonPanel.COMPARISON_BOTTOM_MARGIN+ComparisonPanel.COMPARISON_TOP_MARGIN;
		return new Dimension(width,height);
	}

	public void removeLayoutComponent(Component comp) {
		// TODO Auto-generated method stub
	}
}
