/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.layout;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.Rectangle;

import org.synteny.ihm.OrthologPanel;
import org.synteny.ihm.ProteinPanel;
import org.synteny.ihm.SimpleBlocPanel;

public class ParalogLayout implements LayoutManager{
	
	SimpleBlocPanel _blocPanel;
	int _maxHeight;
	
	public ParalogLayout(SimpleBlocPanel sbp){
		_blocPanel = sbp;
		_maxHeight = 0;
	}

	public void addLayoutComponent(String name, Component comp) {
		// TODO Auto-generated method stub
		
	}

	public void layoutContainer(Container parent) {
		for(Component c : parent.getComponents()){
			int pos = ((OrthologPanel)c).getOrtholog().getRefProtein().getGenomePosition()-_blocPanel.getBloc().getGenomeStart();
			Rectangle rect = new Rectangle(pos*(OrthologPanel.PROTEIN_WIDTH+OrthologPanel.PROTEIN_MARGIN)+OrthologPanel.PROTEIN_MARGIN,SimpleBlocPanel.BLOC_MARGIN,c.getPreferredSize().width,c.getPreferredSize().height);
			c.setBounds(rect);
			_maxHeight = c.getPreferredSize().height;
		}
	}

	public Dimension minimumLayoutSize(Container parent) {
		return new Dimension(100,100);
	}

	public Dimension preferredLayoutSize(Container parent) {
		int width = _blocPanel.getBloc().getMaximumSize()*(ProteinPanel.PROTEIN_WIDTH+ProteinPanel.PROTEIN_MARGIN);
		int height = parent.getComponents()[0].getPreferredSize().height+SimpleBlocPanel.BLOC_MARGIN*2;
		return new Dimension(width,height);
	}

	public void removeLayoutComponent(Component comp) {
		// TODO Auto-generated method stub
		
	}
	
	
}
