/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.layout;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.Rectangle;

import org.synteny.ihm.ProteinPanel;
import org.synteny.ihm.RefProteomePanel;

public class ProteomeLayout implements LayoutManager {

	int maxHeight = 0;
	public void addLayoutComponent(String name, Component comp) {
	}

	public void layoutContainer(Container parent) {
		for(Component c : parent.getComponents()){
			int pos = ((ProteinPanel)c).getProtein().getGenomePosition();
			Rectangle rect = new Rectangle(pos*(ProteinPanel.PROTEIN_WIDTH+ProteinPanel.PROTEIN_MARGIN)+ProteinPanel.PROTEIN_MARGIN*2,0,c.getPreferredSize().width,c.getPreferredSize().height);
			c.setBounds(rect);
			maxHeight = c.getPreferredSize().height;
		}
	}

	public Dimension minimumLayoutSize(Container parent) {
		return new Dimension(100,100);
	}

	public Dimension preferredLayoutSize(Container parent) {
		int width = 0;
		
		if(((RefProteomePanel)parent).getGenome()!=null)
			width = ((RefProteomePanel)parent).getGenome().getSize()*(ProteinPanel.PROTEIN_WIDTH+ProteinPanel.PROTEIN_MARGIN);
		int height = maxHeight;
		return new Dimension(width,height);
	}

	public void removeLayoutComponent(Component comp) {

	}

}
