/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.preferences;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class AlignementSettingsPanel extends JPanel implements Saveable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -2856913504627173417L;

	JTextField musclePathField;
	JButton fileButton;
	
	public AlignementSettingsPanel(){
		super();
		setLayout(new FlowLayout());
		add(new JLabel("Path to muscle"));
		setName("Alignment settings");
		JPanel jp = new JPanel();
		jp.setLayout(new FlowLayout());
		jp.add(getMusclePath());
		jp.add(getFileButton());
		
		add(jp);
	}
	
	public void save() {
		Settings.getInstance().setMultipleAlignmentPath(getMusclePath().getText());
	}
	
	public JButton getFileButton(){
		if(fileButton == null){
			fileButton = new JButton("...");
			fileButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					JFileChooser jf = new JFileChooser();
					if(jf.showOpenDialog(AlignementSettingsPanel.this)==JFileChooser.APPROVE_OPTION){
						getMusclePath().setText(jf.getSelectedFile().getAbsolutePath());
					}
				}
			});
		}
		return fileButton;
	}

	
	public JTextField getMusclePath(){
		if(musclePathField == null){
			musclePathField = new JTextField();
			musclePathField.setText(Settings.getInstance().getMultipleAlignmentPath());
		}
		return musclePathField;
	}
}
