/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.preferences;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextField;


public class LoginSettingsPanel extends JPanel implements Saveable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6121177786989484912L;
	JTextField _host;
	JTextField _user;
	JTextField _pass;
	JTextField _database;
	JTextField _port;
	
	public LoginSettingsPanel(Settings settings){
		super();
		setName("Login Informations");
		this.settings = settings;
		setLayout(new BorderLayout());
		
		JPanel jp = new JPanel();
		jp.setLayout(new GridLayout(5,2));
		
		JLabel host = new JLabel("Host");
		_host = new JTextField();
		_host.setText(getSettings().getDBHost());
		jp.add(host);
		jp.add(_host);
		
		
		JLabel user = new JLabel("User");
		_user= new JTextField();
		_user.setText(getSettings().getDBUser());
		jp.add(user);
		jp.add(_user);

		JLabel pass = new JLabel("Password");
		_pass = new JPasswordField();
		_pass.setText(getSettings().getDBPassword());
		jp.add(pass);
		jp.add(_pass);
		
		JLabel database = new JLabel("Database");
		_database = new JTextField();
		_database.setText(getSettings().getDBName());
		jp.add(database);
		jp.add(_database);
		
		JLabel port = new JLabel("Port");
		_port = new JTextField();
		_port.setText(getSettings().getDBPort());
		jp.add(port);
		jp.add(_port);
		
		add(new JScrollPane(jp),BorderLayout.CENTER);
	}

	/**
	 * @uml.property  name="settings"
	 * @uml.associationEnd  inverse="loginSettingsPanel:org.synteny.ihm.preferences.Settings"
	 */
	private Settings settings;

	/**
	 * Getter of the property <tt>settings</tt>
	 * @return  Returns the settings.
	 * @uml.property  name="settings"
	 */
	public Settings getSettings() {
		return settings;
	}

	/**
	 * Setter of the property <tt>settings</tt>
	 * @param settings  The settings to set.
	 * @uml.property  name="settings"
	 */
	public void setSettings(Settings settings) {
		this.settings = settings;
	}

	public void saveSettings(){
		
	}

	public void save() {
		getSettings().setDBHost(_host.getText());
		getSettings().setDBName(_database.getText());
		getSettings().setDBPassword(_pass.getText());
		getSettings().setDBPort(_port.getText());
		getSettings().setDBUser(_user.getText());
	}
}
