/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.preferences;

import java.util.Collection;

import org.synteny.Genome;
import org.synteny.SpeciesTree;

public class SelectDisplayedGenomesPanel extends SelectComparedGenomesPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = -2056634652949545130L;
	public SelectDisplayedGenomesPanel(SpeciesTree sptree,String title, boolean titlepane){
		super(sptree,title,titlepane);
	}

	/**
	 * @uml.property  name="compGenomesPanel"
	 * @uml.associationEnd  inverse="selectDisplayedGenomesPanel:org.synteny.ihm.preferences.CompGenomesPanel"
	 */
	private CompGenomesPanel compGenomesPanel;

	/**
	 * Getter of the property <tt>compGenomesPanel</tt>
	 * @return  Returns the compGenomesPanel.
	 * @uml.property  name="compGenomesPanel"
	 */
	public CompGenomesPanel getCompGenomesPanel() {
		return compGenomesPanel;
	}

	/**
	 * Setter of the property <tt>compGenomesPanel</tt>
	 * @param compGenomesPanel  The compGenomesPanel to set.
	 * @uml.property  name="compGenomesPanel"
	 */
	public void setCompGenomesPanel(CompGenomesPanel compGenomesPanel) {
		this.compGenomesPanel = compGenomesPanel;
	}
	
	public void setRestriction(Collection<Genome> genomes){
	}
}
