/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.ihm.preferences;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.synteny.factory.IconFactory;

public class TabLabel extends JPanel{


	/**
	 * 
	 */
	private static final long serialVersionUID = -5864210904621947862L;

	private JButton _closeButton;
	private JLabel _label;
	
	
	public TabLabel(String content){
		super();
		init(content,true);
	}

	public TabLabel(String content, boolean closeButton){
		super();
		init(content,closeButton);
	}

	public void init(String content,boolean closeButton){
		setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
		_label = new JLabel("  "+content);
		_label.setOpaque(false);
		add(_label);
		if(closeButton){
			_closeButton = new JButton();
			_closeButton.setPreferredSize(new Dimension(20,20));
			_closeButton.setIcon(IconFactory.getInstance().getCloseIcon());
			add(Box.createHorizontalGlue());
			add(_closeButton);
		}else{
			add(Box.createHorizontalGlue());
			add(Box.createRigidArea(new Dimension(30,30)));
		}
		setOpaque(false);
		setPreferredSize(new Dimension(200,30));
	}


	public void paintComponent(Graphics g){
		Graphics2D g2d = (Graphics2D) g;
		g2d.setPaint(new GradientPaint(0,0,new Color(175, 204, 240),getWidth(),getHeight(),Color.white,true));
		g2d.fillRect(0,0,getWidth(),getHeight());
		/*		ImageIcon i = IconFactory.getInstance().getTabImage();
		g.drawImage(i.getImage(),0,0,this);
		super.paintComponent(g);
		 */
	}

	public JButton getCloseButton(){
		return _closeButton;
	}
	
	public void setText(String t){
		_label.setText(t);
		updateUI();
	}
}
