/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package org.synteny.search;

import java.util.Collection;

import org.exceptions.SyntenyNotInitializedException;
import org.synteny.Genome;


public interface ProteinSearcher {

	/**
	 * @return  Returns the genome.
	 * @uml.property  name="genome"
	 * @uml.associationEnd  inverse="proteinSearcher:org.synteny.Genome"
	 */
	public Genome getGenome();

	/**
	 * Setter of the property <tt>genome</tt>
	 * @param genome  The genome to set.
	 * @uml.property  name="genome"
	 */
	public void setGenome(Genome genome);


	/**
	 * @return TODO
	 */
	public abstract Collection searchProtein(String pattern,boolean function, boolean genename) throws SyntenyNotInitializedException;
	
	public abstract Collection searchBlocProtein(int blocWidth, int blocHeight) throws SyntenyNotInitializedException;


}
