/*
 * Copyright 2008 IGM/LRI,  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 *  This file is part of SynteView.
 *  SynteView is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  SynteView is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with SynteView.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Please contact Frederic LEMOINE (frederic.lemoine@lri.fr ) if you need 
 * additional information or have any questions.
 * 
 */

package run;

import java.util.Locale;

import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import org.synteny.Synteny;
import org.synteny.factory.DatabaseSyntenyFactory;
import org.synteny.factory.HttpSyntenyFactory;
import org.synteny.factory.SyntenyFactory;
import org.synteny.ihm.SyntenyFrame;
import org.synteny.ihm.preferences.Settings;

import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

public class SynteView {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		if(System.getProperty ( "os.name" ).toLowerCase().contains("windows")){
			try {
				UIManager.setLookAndFeel(new WindowsLookAndFeel());
			} catch (UnsupportedLookAndFeelException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		SyntenyFactory sf;
		if(Settings.getInstance().getConnectionMode().equals("db")){
			sf = new DatabaseSyntenyFactory();
		}else{
			sf = new HttpSyntenyFactory();
		}
		Synteny synteny = sf.newSyntenyInstance();
		new SyntenyFrame(synteny);
	}
}
